-- get the addon namespace
local addon, ns = ...

-- get the config values
local cfg = ns.cfg

-- get the library
local lib = ns.lib

if cfg.release>6 then
lib.classes["DEATHKNIGHT"] = {}
local t,t2,s,n

lib.classpreload["DEATHKNIGHT"] = function()
	lib.SetPower("RUNIC_POWER")
	lib.AddResourceBar(cfg.Power.max,cfg.Power.max-20)
	lib.ChangeResourceBarType(cfg.Power.type)
	cfg.des_update=24*0.3
	
	
	--lib.AddRuneSpell("it",{45477},{0,0,1}) -- Icy Touch
	--lib.AddRuneSpell("ps",{45462},{0,1,0}) -- Plague Strike
end

lib.classes["DEATHKNIGHT"][2] = function () --Frost
	cfg.talents={
		["Sindragosa"]=IsPlayerSpell(152279),
		["Obliteration"]=IsPlayerSpell(207256),
		["Frostscythe"]=IsPlayerSpell(207230),
	}
	cfg.heal=60
	lib.AddAura("Frost Fever",55095,"debuff","target")
	lib.SetTrackDOT("Frost Fever")
	lib.AddRuneSpell("Howling Blast",{49184},1)
	lib.AddRuneSpell("Glacial Advance",{194913},1)
	lib.AddRuneSpell("Remorseless Winter",{196770},1,true)
	lib.AddRuneSpell("Obliterate",{49020},2)
	lib.AddSpell("Obliteration",{207256},true)
	lib.AddSpell("Hungering Rune Weapon",{207127})
	lib.AddSpell("Horn of Winter",{57330})
	lib.AddRuneSpell("Frostscythe",{207230},1)
	lib.AddSpell("Pillar of Frost",{51271},true)
	lib.AddSpell("Frost Strike",{49143})
	cfg.gcd="Frost Strike"
	lib.AddAura("Rime",59052,"buff","player")
	lib.AddAura("Killing Machine",51124,"buff","player")
	
	
	lib.SetTrackAura("Killing Machine")
	lib.SetAuraFunction("Killing Machine","OnApply",function()
		lib.UpdateTrackAura(cfg.GUID["player"],0)
	end)
	lib.SetAuraFunction("Killing Machine","OnFade",function()
		lib.UpdateTrackAura(cfg.GUID["player"])
	end)
		
	cfg.plistdps = {}
	table.insert(cfg.plistdps,"Kick")
	table.insert(cfg.plistdps,"ds_proc")
	table.insert(cfg.plistdps,"Safe")
	table.insert(cfg.plistdps,"Death Pact")
	table.insert(cfg.plistdps,"Pillar of Frost")
	table.insert(cfg.plistdps,"hb_range")
	if cfg.talents["Obliteration"] then
		table.insert(cfg.plistdps,"Obliteration")
	end
	if cfg.talents["Sindragosa"] then
		table.insert(cfg.plistdps,"Sindragosa")
	end
	if cfg.talents["Frostscythe"] then
		table.insert(cfg.plistdps,"Frostscythe_km")
	else
		table.insert(cfg.plistdps,"fs_cap")
		table.insert(cfg.plistdps,"ob_km")
	end
	if cfg.talents["Obliteration"] then
		table.insert(cfg.plistdps,"fs_Obliteration")
	end
	table.insert(cfg.plistdps,"hb_rime")
	table.insert(cfg.plistdps,"ds_heal")
	if cfg.talents["Frostscythe"] then
		table.insert(cfg.plistdps,"fs_cap")
	end
	table.insert(cfg.plistdps,"ds_proc")
	table.insert(cfg.plistdps,"Remorseless Winter2")
	table.insert(cfg.plistdps,"hb_ff")
	table.insert(cfg.plistdps,"Glacial Advance_nocap")
	if cfg.talents["Frostscythe"] then
		table.insert(cfg.plistdps,"Frostscythe_aoe")
	else
		table.insert(cfg.plistdps,"Howling Blast_aoe")
	end
	table.insert(cfg.plistdps,"Obliterate_nocap")
	table.insert(cfg.plistdps,"Horn of Winter")
	table.insert(cfg.plistdps,"Frost Strike")	
	table.insert(cfg.plistdps,"erw_runes")
	table.insert(cfg.plistdps,"end")
	
	cfg.plistdps_Sindragosa = {}
	table.insert(cfg.plistdps_Sindragosa,"Pillar of Frost")
	table.insert(cfg.plistdps_Sindragosa,"hb_range")
	if cfg.talents["Frostscythe"] then
		table.insert(cfg.plistdps_Sindragosa,"Frostscythe_km")
	else
		table.insert(cfg.plistdps_Sindragosa,"ob_km")
	end
	table.insert(cfg.plistdps_Sindragosa,"hb_rime")
	table.insert(cfg.plistdps_Sindragosa,"Remorseless Winter2")
	table.insert(cfg.plistdps_Sindragosa,"hb_ff")
	if cfg.talents["Frostscythe"] then
		table.insert(cfg.plistdps_Sindragosa,"Frostscythe_aoe")
	else
		table.insert(cfg.plistdps_Sindragosa,"Howling Blast_aoe")
	end
	table.insert(cfg.plistdps_Sindragosa,"Obliterate_nocap")
	table.insert(cfg.plistdps_Sindragosa,"Horn of Winter")
	table.insert(cfg.plistdps_Sindragosa,"erw_runes")
	
	cfg.plistaoe = {}
	table.insert(cfg.plistaoe,"Kick")
	table.insert(cfg.plistaoe,"ds_proc")
	table.insert(cfg.plistaoe,"Safe")
	table.insert(cfg.plistaoe,"Death Pact")
	table.insert(cfg.plistaoe,"Pillar of Frost")
	table.insert(cfg.plistaoe,"hb_range")
	if cfg.talents["Frostscythe"] and cfg.talents["Obliteration"] then
		table.insert(cfg.plistaoe,"Obliteration")
	end
	if cfg.talents["Sindragosa"] then
		table.insert(cfg.plistaoe,"Sindragosa")
	end
	if cfg.talents["Frostscythe"] then
		table.insert(cfg.plistaoe,"Frostscythe_km")
	end
	if cfg.talents["Obliteration"] then
		table.insert(cfg.plistaoe,"fs_Obliteration")
	end
	table.insert(cfg.plistaoe,"hb_ff")
	table.insert(cfg.plistaoe,"Remorseless Winter")
	table.insert(cfg.plistaoe,"Glacial Advance")
	table.insert(cfg.plistaoe,"ds_heal")
	table.insert(cfg.plistaoe,"fs_cap")
	if cfg.talents["Frostscythe"] then
		table.insert(cfg.plistaoe,"Frostscythe")
	else
		table.insert(cfg.plistaoe,"Howling Blast")
	end
	table.insert(cfg.plistaoe,"Horn of Winter")
	table.insert(cfg.plistaoe,"Frost Strike")	
	table.insert(cfg.plistaoe,"erw_runes")
	table.insert(cfg.plistaoe,"end")
	
	cfg.case = {
	
		["Remorseless Winter2"] = function ()
			if cfg.Power.now<=cfg.Power.max-10 and cfg.TrackDOT.num>1 then 
				return lib.SimpleCDCheck("Remorseless Winter")
			end
			return nil
		end,
		["Frostscythe_aoe"] = function ()
			if cfg.Power.now<=cfg.Power.max-10 and cfg.TrackDOT.num>=3 then 
				return lib.SimpleCDCheck("Frostscythe")
			end
			return nil
		end,
		["Howling Blast_aoe"] = function ()
			if cfg.Power.now<=cfg.Power.max-10 and cfg.TrackDOT.num>=5 then 
				return lib.SimpleCDCheck("Howling Blast",lib.GetAura({"Killing Machine"}))
			end
			return nil
		end,
		["fs_cap"] = function ()
			if cfg.Power.now>=cfg.Power.max-20 or (lib.GetAura({"Killing Machine"})>lib.GetSpellCD("Frostscythe") and cfg.Power.now>=cfg.Power.max-10) then 
				return lib.SimpleCDCheck("Frost Strike")
			end
			return nil
		end,
		["fs_cap_aoe"] = function ()
			if cfg.Power.now>=cfg.Power.max-10 then 
				return lib.SimpleCDCheck("Frost Strike")
			end
			return nil
		end,
		["fs_Obliteration"] = function ()
			if lib.GetAura({"Obliteration"})>lib.GetSpellCD("Frost Strike") and lib.GetAura({"Obliteration"})>lib.GetAura({"Killing Machine"}) then
				return lib.SimpleCDCheck("Frost Strike",lib.GetAura({"Killing Machine"}))
			end
			return nil
		end,
		
		["Glacial Advance_nocap"] = function ()
			if cfg.Power.now<=cfg.Power.max-10 then 
				return lib.SimpleCDCheck("Glacial Advance")
			end
			return nil
		end,
		["Obliterate_nocap"] = function ()
			if cfg.Power.now<=cfg.Power.max-20 then 
				return lib.SimpleCDCheck("Obliterate")
			end
			return nil
		end,
		["hb_ff"] = function()
			if lib.GetAura({"Killing Machine"})>0 then return nil end
			return lib.SimpleCDCheck("Howling Blast",lib.GetAura({"Frost Fever"})-cfg.des_update)
		end,
		
		["hb_rime"] = function ()
			if lib.GetAura({"Rime"})>lib.GetSpellCD("Howling Blast") then
				return lib.SimpleCDCheck("Howling Blast")
			end
			return nil
		end,
		["hb_nokm"] = function()
			if lib.GetAura({"Killing Machine"})>0 then return nil end
			return lib.SimpleCDCheck("Howling Blast")
		end,
		
		["hb_range"] = function()
			if lib.inrange("Frost Strike") then return nil end
			return lib.SimpleCDCheck("Howling Blast",lib.GetAura({"Frost Fever"})-cfg.des_update)
		end,
		["Frostscythe_km"] = function ()
			if lib.GetAura({"Killing Machine"}) > lib.GetSpellCD("Frostscythe") then
				return lib.SimpleCDCheck("Frostscythe")
			end
			return nil
		end,
		["Obliteration"] = function ()
			if cfg.Power.now>=50 then
				return lib.SimpleCDCheck("Obliteration",lib.GetAura({"Killing Machine"}))
			end
			return nil
		end,
		["ob_km"] = function ()
			if lib.GetAura({"Killing Machine"}) > lib.GetSpellCD("Obliterate") then
				return lib.SimpleCDCheck("Obliterate")
			end
			return nil
		end,
		["ob_unholy"] = function ()
			if lib.GetNumRune(2)>0 then
				return lib.SimpleCDCheck("Obliterate",lib.RuneTypeCD(2)) --,true
			end
			return nil
		end,
		["ob_2unholy"] = function ()
			if lib.GetNumRune(2)>1 then
				return lib.SimpleCDCheck("Obliterate",lib.RuneTypeCD(2,true))
			else
				return nil
			end
		end,
		["hb_2frost"] = function ()
			if lib.GetNumRune(3)>1 then
				return lib.SimpleCDCheck("Howling Blast",lib.RuneTypeCD(3,true))
			else
				return nil
			end
		end,
		["hb_2death"] = function ()
			if lib.GetNumRune(4)>1 then
				return lib.SimpleCDCheck("Howling Blast",lib.RuneTypeCD(4,true))
			else
				return nil
			end
		end,
		["ps_aoe_2unholy"] = function ()
			if lib.GetNumRune(2)>0 then
				return lib.SimpleCDCheck("ps",lib.RuneTypeCD(2,true))
			else
				return nil
			end
		end,
		["fs_km"] = function ()
			if lib.GetAura({"Killing Machine"}) > lib.GetSpellCD("Frost Strike") then 
				return lib.SimpleCDCheck("Frost Strike")
			end
			return nil
		end,
		["fs_cap76"] = function ()
			if cfg.Power.now>=76 then 
				return lib.SimpleCDCheck("Frost Strike")
			end
			return nil
		end,
	}
	
	if cfg.talents["Sindragosa"] then
		lib.AddSpell("Sindragosa",{152279},true)
		lib.SetAuraFunction("Sindragosa","OnApply",function()
			if cfg.mode=="aoe" and cfg.plistdps_Sindragosa_aoe then
				cfg.plist=cfg.plistdps_Sindragosa_aoe
			else
				cfg.plist=cfg.plistdps_Sindragosa
			end
			cfg.Update=true
		end)
		lib.SetAuraFunction("Sindragosa","OnFade",function()
			if cfg.mode=="aoe" then
				cfg.plist=cfg.plistaoe
			else
				cfg.plist=cfg.plistdps
			end
			cfg.Update=true
		end)
		cfg.case["Sindragosa"] = function ()
			if cfg.Power.now>=75 then
				return lib.SimpleCDCheck("Sindragosa")
			end
			return nil
		end
	end
	
	lib.AddRangeCheck({
	{"Frost Strike",nil},
	{"Howling Blast",{0,0,1,1}},
	})
	return true
end

lib.classes["DEATHKNIGHT"][3] = function () --Unholy
	cfg.talents={
		["Ebon Fever"]=IsPlayerSpell(207269),
		["Defile"]=IsPlayerSpell(152280),
		["Dark Arbiter"]=IsPlayerSpell(207349),
		["Soul Reaper"]=IsPlayerSpell(130736),
		["Clawing Shadows"]=IsPlayerSpell(207311),
		["Necrosis"]=IsPlayerSpell(207346),
		["Shadow Infusion"]=IsPlayerSpell(198943),
	}
	if cfg.talents["Ebon Fever"] then
		cfg.des_update=21/2*0.3
	else
		cfg.des_update=21*0.3
	end
	if cfg.talents["Dark Arbiter"] then
		cfg.gargoyle=15
	else
		cfg.gargoyle=40
	end
	cfg.heal=60
	lib.AddRuneSpell("Festering Strike",{85948},2) -- Festering Strike
	lib.AddRuneSpell("Scourge Strike",{207311,55090},1) -- Scourge Strike
	
	lib.AddRuneSpell("Outbreak",{77575},1)
	lib.AddAura("Virulent Plague",191587,"debuff","target")
	lib.SetTrackDOT("Virulent Plague")
	lib.AddAura("Festering Wound",194310,"debuff","target")
	lib.SetTrackAura("Festering Wound")
	lib.SetAuraFunction("Festering Wound","OnStacks",function()
		lib.UpdateTrackAura(cfg.GUID["target"],lib.GetAuraStacks("Festering Wound")>0 and lib.GetAuraStacks("Festering Wound") or nil)
	end)
	lib.AddSpell("Summon Gargoyle",{207349,49206}) -- Summon Gargoyle
	--lib.ChangeSpellId("Summon Gargoyle",207349,cfg.talents["Dark Arbiter"])
	lib.AddSpell("Raise Dead",{46584})
	lib.AddSpell("Blighted Rune Weapon",194918,true)
	lib.AddSpell("Dark Transformation",63560,"pet") -- Dark Transformation
	lib.AddSpell("Death Coil",47541)
	lib.AddAura("Sudden Doom",81340,"buff","player") -- Sudden Doom
	lib.AddAura("Necrosis",216974,"buff","player")
	lib.SetAuraFunction("Sudden Doom","OnApply",function()
		lib.ReloadSpell("Death Coil")
	end)
	lib.SetAuraFunction("Sudden Doom","OnFade",function()
		lib.ReloadSpell("Death Coil")
	end)
	lib.AddRuneSpell("Soul Reaper",{130736},{0,0,1},"target") -- Soul Reaper
	
	lib.AddAura("Soul Reaper_player",215711,"buff","player")
	lib.AddRuneSpell("Death and Decay",{152280,43265},{0,1,0})
	--lib.ChangeSpellId("Death and Decay",152280,cfg.talents["Defile"])
	lib.AddAura("Death and Decay",188290,"buff","player")
	lib.AddRuneSpell("Epidemic",{207317},1)
	
	cfg.plistdps = {}
	table.insert(cfg.plistdps,"Kick")
	table.insert(cfg.plistdps,"ds_proc")
	table.insert(cfg.plistdps,"Raise Dead")
	table.insert(cfg.plistdps,"ds_heal")
	if cfg.talents["Soul Reaper"] then
		table.insert(cfg.plistdps,"Festering Strike_Soul Reaper")
		table.insert(cfg.plistdps,"Scourge Strike_Soul Reaper")
	end
	table.insert(cfg.plistdps,"Outbreak_vp_re")
	table.insert(cfg.plistdps,"Dark Transformation")
	table.insert(cfg.plistdps,"Blighted Rune Weapon")
	if cfg.talents["Dark Arbiter"] then
		table.insert(cfg.plistdps,"Death Coil_Arbiter")
		--aoe
		table.insert(cfg.plistdps,"Death and Decay_aoe_Arbiter")	
		table.insert(cfg.plistdps,"Epidemic_aoe4_Arbiter")
		table.insert(cfg.plistdps,"Scourge Strike_aoe_Arbiter")	
		table.insert(cfg.plistdps,"Epidemic_aoe_Arbiter")
		
		table.insert(cfg.plistdps,"Festering Strike_Arbiter")
		table.insert(cfg.plistdps,"Scourge Strike_Arbiter")
	end
	
	table.insert(cfg.plistdps,"Summon Gargoyle")
	table.insert(cfg.plistdps,"Death Coil_cap")
	table.insert(cfg.plistdps,"Death Coil_proc")
	if cfg.talents["Soul Reaper"] then
		table.insert(cfg.plistdps,"Soul Reaper_Festering Wound")
		--table.insert(cfg.plistdps,"Festering Strike_Soul Reaper")
		--table.insert(cfg.plistdps,"Scourge Strike_Soul Reaper")
	end
	if cfg.talents["Defile"] then
		table.insert(cfg.plistdps,"Death and Decay")
	end

	table.insert(cfg.plistdps,"Death and Decay_aoe")	
	table.insert(cfg.plistdps,"Epidemic_aoe4")
	table.insert(cfg.plistdps,"Scourge Strike_aoe")	
	table.insert(cfg.plistdps,"Epidemic_aoe")	
	
	table.insert(cfg.plistdps,"Festering Strike_Festering Wound")
	if cfg.talents["Necrosis"] then
		table.insert(cfg.plistdps,"Scourge Strike_Necrosis")
	end
	table.insert(cfg.plistdps,"Scourge Strike_Festering Wound")
	if cfg.talents["Shadow Infusion"] then
		table.insert(cfg.plistdps,"Death Coil_Shadow Infusion")
	elseif cfg.talents["Dark Arbiter"] then
		table.insert(cfg.plistdps,"Death Coil_Dark Arbiter")
	end
	if not cfg.talents["Dark Arbiter"] and not cfg.talents["Shadow Infusion"] then
		table.insert(cfg.plistdps,"Death Coil")
	end
	table.insert(cfg.plistdps,"end")
	
	--[[table.insert(cfg.plistdps,"Kick")
	table.insert(cfg.plistdps,"ds_proc")
	table.insert(cfg.plistdps,"Raise Dead")
	table.insert(cfg.plistdps,"Scourge Strike_Soul Reaper")
	table.insert(cfg.plistdps,"Outbreak_vp")
	table.insert(cfg.plistdps,"Dark Transformation")
	table.insert(cfg.plistdps,"Death and Decay_aoe")	
	table.insert(cfg.plistdps,"Scourge Strike_aoe")	
	table.insert(cfg.plistdps,"Epidemic_aoe")	
	table.insert(cfg.plistdps,"Summon Gargoyle")
	table.insert(cfg.plistdps,"ds_heal")
	table.insert(cfg.plistdps,"Death Coil_cap")
	table.insert(cfg.plistdps,"Festering Strike_Festering Wound")
	table.insert(cfg.plistdps,"Blighted Rune Weapon")
	if cfg.talents["Defile"] then
		table.insert(cfg.plistdps,"Death and Decay")
	end
	table.insert(cfg.plistdps,"Soul Reaper_Festering Wound")
	table.insert(cfg.plistdps,"Scourge Strike_Festering Wound")
	table.insert(cfg.plistdps,"Death Coil")
	table.insert(cfg.plistdps,"end")--]]
	
	cfg.plistaoe=nil
	
--[[	cfg.plistaoe = {}
	table.insert(cfg.plistaoe,"Kick")
	table.insert(cfg.plistaoe,"Horn of Winter")
	table.insert(cfg.plistaoe,"Death Pact")
	table.insert(cfg.plistaoe,"Dispell")
	table.insert(cfg.plistaoe,"dt_5si")
	table.insert(cfg.plistaoe,"Raise Dead")
	table.insert(cfg.plistaoe,"Soul Reaper")
	table.insert(cfg.plistaoe,"Unholy Blight_des")
	table.insert(cfg.plistaoe,"Sindragosa")
	table.insert(cfg.plistaoe,"Outbreak_des")
	table.insert(cfg.plistaoe,"Plague Leech_2sec")
	table.insert(cfg.plistaoe,"ps_bp")
	table.insert(cfg.plistaoe,"Death and Decay")
	if cfg.talents["Unholy Blight"] then
		table.insert(cfg.plistaoe,"fes_Blight")
		table.insert(cfg.plistaoe,"bb_Blight")
	else
		table.insert(cfg.plistaoe,"bb_death")
	end
	table.insert(cfg.plistaoe,"ss_unholy")
	table.insert(cfg.plistaoe,"Festering Strike")
	table.insert(cfg.plistaoe,"dc_no5si")
	table.insert(cfg.plistaoe,"dc_noMAX")
	table.insert(cfg.plistaoe,"Blood Tap")
	table.insert(cfg.plistaoe,"Plague Leech_runes")
	table.insert(cfg.plistaoe,"erw_runes")
	table.insert(cfg.plistaoe,"end")]]--
	
	cfg.plist=cfg.plistdps

	cfg.case = {
		["Death and Decay_aoe"] = function ()
			if cfg.TrackDOT.num>=2 then 
				return lib.SimpleCDCheck("Death and Decay")
			end
			return nil
		end,
		["Scourge Strike_aoe"] = function()
			if cfg.TrackDOT.num>=2 and lib.GetAura({"Death and Decay"})>lib.GetSpellCD("Scourge Strike") then
				return lib.SimpleCDCheck("Scourge Strike")
			end
			return nil
		end,
		--Soul Reaper
		["Soul Reaper_Festering Wound"] = function()
			if lib.GetAuraStacks("Festering Wound")>=3 then
				return lib.SimpleCDCheck("Soul Reaper",lib.GetNumRunesReadyCD(4))
			end
			return nil
		end,
		["Scourge Strike_Soul Reaper"] = function()
			if lib.GetAura({"Soul Reaper"})>lib.GetSpellCD("Scourge Strike") and lib.GetAuraStacks("Festering Wound")>0 then
				return lib.SimpleCDCheck("Scourge Strike")
			end
			return nil
		end,
		["Festering Strike_Soul Reaper"] = function()
			if lib.GetAura({"Soul Reaper"})>lib.GetSpellCD("Festering Strike") then
				return lib.SimpleCDCheck("Festering Strike",lib.GetAura({"Festering Wound"}))
			end
			return nil
		end,
		["Epidemic_aoe"] = function()
			if cfg.TrackDOT.num>=2 then
				return lib.SimpleCDCheck("Epidemic",lib.GetAura({"Death and Decay"}))
			end
			return nil
		end,
		["Epidemic_aoe4"] = function()
			if cfg.TrackDOT.num>4 then
				return lib.SimpleCDCheck("Epidemic")
			end
			return nil
		end,
		["Death Coil_cap"] = function ()
			if cfg.Power.now>=cfg.Power.max-20 then 
				return lib.SimpleCDCheck("Death Coil")
			end
			return nil
		end,
		["Death Coil_proc"] = function ()
			if lib.GetAura({"Sudden Doom"})>lib.GetSpellCD("Death Coil") then 
				if cfg.talents["Dark Arbiter"] then
					if lib.GetAura({"Sudden Doom"})<lib.GetSpellCD("Summon Gargoyle")+1.5 then
						return lib.SimpleCDCheck("Death Coil")
					end
				else
					return lib.SimpleCDCheck("Death Coil")
				end
			end
			return nil
		end,
		["Death Coil_Shadow Infusion"] = function ()
			if cfg.talents["Dark Arbiter"] then
				if lib.GetSpellCD("Summon Gargoyle")>math.max(lib.GetSpellCD("Death Coil"),lib.GetAura({"Dark Transformation"}))+15 then
					return lib.SimpleCDCheck("Death Coil",lib.GetAura({"Dark Transformation"}))
				end
			else
				return lib.SimpleCDCheck("Death Coil",lib.GetAura({"Dark Transformation"}))
			end
			return nil
		end,
		["Death Coil_Dark Arbiter"] = function ()
			if lib.GetSpellCD("Summon Gargoyle")>lib.GetSpellCD("Death Coil")+15 then
				return lib.SimpleCDCheck("Death Coil")
			end
			return nil
		end,
		
		["Summon Gargoyle"] = function ()
			if cfg.talents["Dark Arbiter"] then
				if cfg.Power.now>=cfg.Power.max-20 then 
					return lib.SimpleCDCheck("Summon Gargoyle")
				end
			else
				return lib.SimpleCDCheck("Summon Gargoyle")
			end
			return nil
		end,
		
		
		--Arbiter
		["Death Coil_Arbiter"] = function ()
			if lib.GetSpellCD("Summon Gargoyle")<(180-cfg.gargoyle) then return nil end
			return lib.SimpleCDCheck("Death Coil")
		end,
		["Festering Strike_Arbiter"] = function()
			if lib.GetSpellCD("Summon Gargoyle")<(180-cfg.gargoyle) then return nil end
			if lib.GetAuraStacks("Festering Wound")<=6 then
				return lib.SimpleCDCheck("Festering Strike")
			end
			return nil
		end,
		["Scourge Strike_Arbiter"] = function()
			if lib.GetSpellCD("Summon Gargoyle")<(180-cfg.gargoyle) then return nil end
			if lib.GetAuraStacks("Festering Wound")>0 then
				return lib.SimpleCDCheck("Scourge Strike")
			end
			return nil
		end,
		["Death and Decay_aoe_Arbiter"] = function ()
			if lib.GetSpellCD("Summon Gargoyle")<(180-cfg.gargoyle) then return nil end
			if cfg.TrackDOT.num>=2 then 
				return lib.SimpleCDCheck("Death and Decay")
			end
			return nil
		end,
		["Scourge Strike_aoe_Arbiter"] = function()
			if lib.GetSpellCD("Summon Gargoyle")<(180-cfg.gargoyle) then return nil end
			if cfg.TrackDOT.num>=2 and lib.GetAura({"Death and Decay"})>lib.GetSpellCD("Scourge Strike") then
				return lib.SimpleCDCheck("Scourge Strike")
			end
			return nil
		end,
		["Epidemic_aoe_Arbiter"] = function()
			if lib.GetSpellCD("Summon Gargoyle")<(180-cfg.gargoyle) then return nil end
			if cfg.TrackDOT.num>=2 then
				return lib.SimpleCDCheck("Epidemic")
			end
			return nil
		end,
		["Epidemic_aoe4_Arbiter"] = function()
			if lib.GetSpellCD("Summon Gargoyle")<(180-cfg.gargoyle) then return nil end
			if cfg.TrackDOT.num>4 then
				return lib.SimpleCDCheck("Epidemic")
			end
			return nil
		end,
		
		["Outbreak_vp_re"] = function()
			return lib.SimpleCDCheck("Outbreak",lib.GetAura({"Virulent Plague"})-cfg.des_update)
		end,
		["Outbreak_vp"] = function()
			return lib.SimpleCDCheck("Outbreak",lib.GetAura({"Virulent Plague"}))
		end,
		["Festering Strike_Festering Wound"] = function()
			if cfg.talents["Soul Reaper"] and lib.GetAuraStacks("Festering Wound")>=3 and lib.GetSpellCD("Soul Reaper")<lib.GetNumRunesReadyCD(4) then
				return lib.SimpleCDCheck("Festering Strike",lib.GetNumRunesReadyCD(4))
			else
				if lib.GetAuraStacks("Festering Wound")+lib.IsAura("Blighted Rune Weapon")<5 then
					return lib.SimpleCDCheck("Festering Strike")
				else
					return lib.SimpleCDCheck("Festering Strike",lib.GetAura({"Festering Wound"})-3)
				end
			end
			return nil
		end,
		["Blighted Rune Weapon"] = function()
			if lib.GetAuraStacks("Festering Wound")<5 then
				return lib.SimpleCDCheck("Blighted Rune Weapon")
			else
				return lib.SimpleCDCheck("Blighted Rune Weapon",lib.GetAura({"Festering Wound"})-3)
			end
		end,
		["Scourge Strike_Festering Wound"] = function()
			if lib.GetAuraStacks("Festering Wound")>0 then
				if cfg.talents["Soul Reaper"] and lib.GetSpellCD("Soul Reaper")<lib.GetNumRunesReadyCD(4) then
					return lib.SimpleCDCheck("Scourge Strike",lib.GetNumRunesReadyCD(4))
				else
					return lib.SimpleCDCheck("Scourge Strike")
				end
			end
			return nil
		end,
		["Scourge Strike_Necrosis"] = function()
			if lib.GetAura({"Necrosis"})>lib.GetSpellCD("Scourge Strike") then
				if cfg.talents["Soul Reaper"] and lib.GetSpellCD("Soul Reaper")<lib.GetNumRunesReadyCD(4) then
					return lib.SimpleCDCheck("Scourge Strike",lib.GetNumRunesReadyCD(4)) 
				else
					return lib.SimpleCDCheck("Scourge Strike")
				end
			end
			return nil
		end,
		["Raise Dead"] = function ()
			if cfg.mounted then return nil end
			if cfg.GUID["pet"]~=0 then return nil end
			return lib.SimpleCDCheck("Raise Dead")
		end,
	}
	
	lib.AddRangeCheck({
	{"Festering Strike",nil},
	{"Outbreak",{0,0,1,1}},
	{"Death Coil",{0,1,0,1}},
	})
--[[	lib.rangecheck=function()
		if lib.inrange("Scourge Strike") then
			lib.bdcolor(Heddmain.bd,nil)
		elseif lib.inrange("Outbreak") then
			lib.bdcolor(Heddmain.bd,{0,0,1,1})
		elseif lib.inrange("dc") then
			lib.bdcolor(Heddmain.bd,{0,1,0,1})
		else
			lib.bdcolor(Heddmain.bd,{1,0,0,1})
		end
	end]]--
	--cfg.spells_aoe={"bb"}
	--cfg.spells_single={"Scourge Strike"}
	return true
end



lib.classes["DEATHKNIGHT"][1] = function () --Blood
	cfg.heal=70
	lib.AddRuneSpell("Death's Caress",{195292},1)
	lib.AddAura("Blood Plague",55078,"debuff","target")
	lib.SetTrackDOT("Blood Plague")
	lib.AddSpell("Blood Boil",{50842})
	lib.AddRuneSpell("Death and Decay",{43265},{0,1,0})
	--lib.ChangeSpellId("Death and Decay",152280,cfg.talents["Defile"])
	lib.AddAura("Death and Decay",188290,"buff","player")
	lib.AddAura("Crimson Scourge",81141,"buff","player")
	lib.SetTrackAura("Crimson Scourge")
	lib.SetAuraFunction("Crimson Scourge","OnApply",function()
		lib.UpdateTrackAura(cfg.GUID["player"],0)
	end)
	lib.SetAuraFunction("Crimson Scourge","OnFade",function()
		lib.UpdateTrackAura(cfg.GUID["player"])
	end)
	lib.AddRuneSpell("Marrowrend",{195182},2)
	lib.AddAura("Bone Shield",195181,"buff","player")
	lib.AddRuneSpell("Heart Strike",{206930},1)
	
	lib.AddSpell("Vampiric Blood",{55233},true)
	lib.AddSpell("Rune Tap",{48982})
	lib.AddAura("Rune Tap",171049,"buff","player")
	lib.AddAura("Resolve",158300,"buff","player")
	lib.AddSpell("drw",{49028})
	lib.AddAura("drw",81256,"buff","player")

	cfg.plistdps = {}
	table.insert(cfg.plistdps,"Kick")
	table.insert(cfg.plistdps,"Vampiric Blood")
	table.insert(cfg.plistdps,"Safe")
	table.insert(cfg.plistdps,"Death's Caress_range")
	--table.insert(cfg.plistdps,"ds_VB")
	table.insert(cfg.plistdps,"ds_heal")
	table.insert(cfg.plistdps,"Blood Boil_Blood Plague")
	table.insert(cfg.plistdps,"dnd_Crimson Scourge")
	table.insert(cfg.plistdps,"Death and Decay_aoe")
	table.insert(cfg.plistdps,"drw")
	table.insert(cfg.plistdps,"Marrowrend_Bone Shield")
	table.insert(cfg.plistdps,"Death Strike_cap")
	table.insert(cfg.plistdps,"Death and Decay_Bone Shield")
	table.insert(cfg.plistdps,"Heart Strike_Bone Shield")
	table.insert(cfg.plistdps,"Blood Boil")
	table.insert(cfg.plistdps,"Death Strike")
	table.insert(cfg.plistdps,"erw_runes")
	table.insert(cfg.plistdps,"end")
	
	cfg.plistaoe = nil
	cfg.case = {
		["Death and Decay_aoe"] = function ()
			if cfg.Power.now<=cfg.Power.max-10 and cfg.TrackDOT.num>=3 then 
				return lib.SimpleCDCheck("Death and Decay")
			end
			return nil
		end,
		["Death and Decay_Bone Shield"] = function ()
			if lib.GetAuraStacks("Bone Shield")<5 then
				return nil
			end
			return lib.SimpleCDCheck("Death and Decay")
		end,
		["Heart Strike_Bone Shield"] = function ()
			if lib.GetAuraStacks("Bone Shield")<5 then
				return nil
			end
			return lib.SimpleCDCheck("Heart Strike")
		end,
		["Marrowrend_Bone Shield"] = function ()
			if lib.GetAuraStacks("Bone Shield")<5 then
				return lib.SimpleCDCheck("Marrowrend")
			end
			return lib.SimpleCDCheck("Marrowrend",lib.GetAura({"Bone Shield"})-2)
		end,
		["dnd_Crimson Scourge"] = function ()
			if lib.GetAura({"Crimson Scourge"})>lib.GetSpellCD("Death and Decay") then
				return lib.SimpleCDCheck("Death and Decay")
			end
			return nil
		end,
		["Death's Caress_range"] = function()
			if lib.inrange("Death Strike") then return nil end
			return lib.SimpleCDCheck("Death's Caress",lib.GetAura({"Blood Plague"})-cfg.des_update)
		end,
		["Blood Boil_Blood Plague"] = function()
			return lib.SimpleCDCheck("Blood Boil",lib.GetAura({"Blood Plague"})-cfg.des_update)
		end,
		["drw"] = function()
			return lib.SimpleCDCheck("drw",lib.GetSpellCD("gcd",true))
		end,
		["Vampiric Blood"] = function ()
			if lib.GetUnitHealth("player","percent")<=cfg.heal and lib.GetSpellCD("Vampiric Blood")+1>=lib.GetSpellCD("Death Strike") then
				return lib.SimpleCDCheck("Vampiric Blood")
			end
			return nil
		end,
		["Bone Shield"] = function ()
			if lib.GetUnitHealth("player","percent")<=cfg.heal then
				return lib.SimpleCDCheck("Bone Shield",lib.GetAura({"Bone Shield"}))
			end
			return nil
		end,
		["bb_blood"] = function ()
			return lib.SimpleCDCheck("bb",lib.RuneTypeCD(1))
		end,
		["ds_aoe"] = function ()
			return lib.SimpleCDCheck("Death Strike",max(lib.RuneTypeCD(2),lib.RuneTypeCD(3)))
		end,
		["ds_VB"] = function ()
			if lib.GetUnitHealth("player","percent")<=cfg.heal and lib.GetAura({"Vampiric Blood"})>=lib.GetSpellCD("Death Strike") then
				return lib.SimpleCDCheck("Death Strike")
			end
			return nil
		end,
	}

	lib.AddRangeCheck({
	{"Death Strike",nil},
	{"Death's Caress",{1,0,1,1}},
	})
	--[[lib.rangecheck=function()
		if lib.inrange("Death Strike") then
			lib.bdcolor(Heddmain.bd,nil)
		elseif lib.inrange("it") then
			lib.bdcolor(Heddmain.bd,{0,0,1,1})
		elseif lib.inrange("dc") then
			lib.bdcolor(Heddmain.bd,{0,1,0,1})
		else
			lib.bdcolor(Heddmain.bd,{1,0,0,1})
		end
	end]]

	return true
end

lib.classpostload["DEATHKNIGHT"] = function()
	if cfg.talents["Icy Touch Glyph"] then
		lib.AddDispellTarget("Dispell",{45477},{"Magic"},{0,0,1})
	end

	lib.AddRuneSpell("Death Siphon",{108196},{0,1,0})
	cfg.case["Death Siphon"] = function()
		if not cfg.talents["Necrotic Plague"] then return nil end
		if lib.GetUnitHealth("player","percent")<=70 then
			return lib.SimpleCDCheck("Death Siphon")
		end
		return nil
	end
	
	lib.SetInterrupt("Kick",{47528})

	lib.AddSpell("Empower Rune Weapon",{47568})
	cfg.case["erw_runes"] = function()
		if lib.GetDepletedRunes()<3 then return nil end
		if cfg.Power.now+30<=cfg.Power.max then
			return lib.SimpleCDCheck("Empower Rune Weapon",lib.GetSpellCD("gcd",true))
		end
		return nil
	end
	
	
	lib.AddSpell("Plague Leech",{123693}) -- Plague Leech
	cfg.case["Plague Leech_runes"] = function()
		if lib.GetSpellCD("Plague Leech")<math.min(lib.GetAura({"Frost Fever"}),lib.GetAura({"bp"}))-2 and lib.GetDepletedRunes()>=2 then
			return lib.SimpleCDCheck("Plague Leech")
		end
		return nil
	end
	cfg.case["Plague Leech_2sec"] = function()
		if lib.GetSpellCD("Plague Leech")<math.min(lib.GetAura({"Frost Fever"}),lib.GetAura({"bp"}))-2 then
			return lib.SimpleCDCheck("Plague Leech",math.min(lib.GetAura({"Frost Fever"}),lib.GetAura({"bp"}))-2)
		end
		return nil
	end

	lib.AddSpell("Death Strike",{49998}) -- Death Strike
	cfg.case["Death Strike_cap"] = function ()
		if cfg.Power.now>=cfg.Power.max-20 then 
			return lib.SimpleCDCheck("Death Strike")
		end
		return nil
	end,
	lib.AddAura("Death Strike",101568,"buff","player") -- Dark Succor
	cfg.case["ds_proc"] = function()
		if lib.GetSpellCD("Death Strike")<lib.GetAura({"Death Strike"}) then -- and lib.GetUnitHealth("player","percent")<=cfg.heal
			return lib.SimpleCDCheck("Death Strike")
		end
		return nil
	end
	
	cfg.case["ds_heal"] = function()
		if lib.GetUnitHealth("player","percent")<=cfg.heal then
			return lib.SimpleCDCheck("Death Strike")
		end
		return nil
	end
	
	lib.AddSpell("Blood Tap",{45529}) -- Tap
	lib.AddAura("Blood Tap_stacks",114851,"buff","player")
	cfg.case["Blood Tap"] = function()
		if lib.GetAuraStacks("Blood Tap_stacks")>=5 and lib.GetDepletedRunes()>3 then
			return lib.SimpleCDCheck("Blood Tap",lib.GetSpellCD("gcd",true))
		end
		return nil
	end
	cfg.case["Blood Tap 10"] = function()
		if lib.GetAuraStacks("Blood Tap_stacks")>=10 and lib.GetDepletedRunes()>3 then
			return lib.SimpleCDCheck("Blood Tap",lib.GetSpellCD("gcd",true))
		end
		return nil
	end
	
	cfg.case["ps_unholy"] = function()
		if lib.GetNumRune(2)>0 then
			return lib.SimpleCDCheck("ps",lib.RuneTypeCD(2))
		end
		return nil
	end
	
	
	if not cfg.talents["Necrotic Plague"] then
		cfg.case["bb_dots"] = function()
			if lib.GetAura({"Killing Machine"})>0 then return nil end
			if cfg.TrackDOT.num>0 and lib.GetAura({"bp"})==0 then
				return lib.SimpleCDCheck("bb")
			end
			return nil
		end
		cfg.case["bb_aoe"] = function()
			if cfg.TrackDOT.num>0 and cfg.TrackDOT.num<2 then
				return lib.SimpleCDCheck("bb")
			end
			return nil
		end
		cfg.case["bb_dots_longer"] = function ()
			if lib.GetAura({"bp"})>lib.GetSpellCD("bb") and lib.GetAura({"Frost Fever"})>lib.GetSpellCD("bb") then
				return lib.SimpleCDCheck("bb",math.max(math.min(lib.GetAura({"bp"}),lib.GetAura({"Frost Fever"}))-cfg.des_update,lib.GetAura({"Unholy Blight"})))
			end
			return nil
		end
		
	end
	
	lib.AddSpell("Icebound Fortitude",{48792},true)
	lib.AddSpell("Anti-Magic Shell",{48707},true)
	
	if cfg.talents["Improved Soul Reaper_Perk"] then
		cfg.reaper=45
	else
		cfg.reaper=35
	end
	
	cfg.case["Soul Reaper"] = function()
		if lib.GetUnitHealth("target","percent")>cfg.reaper then return nil end
		if not cfg.pvp and lib.GetTargetLVL()<2 then return nil end
		return lib.SimpleCDCheck("Soul Reaper")
	end

	lib.AddSpell("Death Pact",{48743},"player")
	cfg.case["Death Pact"] = function ()
		if lib.GetUnitHealth("player","percent")<=50 then
			return lib.SimpleCDCheck("Death Pact") --,lib.GetAura({"Vampiric Blood"})
		end
		return nil
	end
	
	lib.AddAurasAlias("DK_saves",{"Bone Shield","Icebound Fortitude","Rune Tap"})
	cfg.case["Safe"] = function ()
		if lib.GetUnitHealth("player","percent")<=cfg.heal then
			return lib.SimpleCDCheck(lib.GetSpellShortestCD({"Bone Shield","Icebound Fortitude","Rune Tap"}),lib.GetAuras("DK_saves"))
		end
		return nil
	end
	
	if cfg.talents["Necrotic Plague"] then
		cfg.case["Outbreak_Necrotic"] = function()
			if lib.GetAuraStacks("bp")<14-lib.GetSpellCD("Outbreak") then
				return lib.SimpleCDCheck("Outbreak")
			end
			return lib.SimpleCDCheck("Outbreak",math.min(lib.GetAura({"bp"}),lib.GetAura({"Frost Fever"})))
		end
		cfg.case["Unholy Blight_des"] = function()
			if lib.GetAuraStacks("bp")<14-lib.GetSpellCD("Unholy Blight") then
				return lib.SimpleCDCheck("Unholy Blight")
			end
			return lib.SimpleCDCheck("Unholy Blight",math.min(lib.GetAura({"bp"}),lib.GetAura({"Frost Fever"}))-1)
		end
	else
		cfg.case["Unholy Blight_des"] = function()
			return lib.SimpleCDCheck("Unholy Blight",math.min(lib.GetAura({"bp"}),lib.GetAura({"Frost Fever"}))-1)
		end
	end
	
	cfg.case["it_ff"] = function()
		if lib.GetAura({"Frost Fever"})>=math.min(lib.GetSpellCD("Outbreak"),lib.GetSpellCD("Plague Leech"),lib.GetSpellCD("Unholy Blight")) then
			return lib.SimpleCDCheck("it",lib.GetAura({"Frost Fever"}))
		end
		return lib.SimpleCDCheck("it",math.max(lib.GetAura({"Frost Fever"})-cfg.des_update,lib.GetAura({"Unholy Blight"})))
	end
	
	cfg.case["it_ff_range"] = function()
		if lib.inrange("Death Strike") then return nil end
		if lib.GetAura({"Frost Fever"})>=math.min(lib.GetSpellCD("Outbreak"),lib.GetSpellCD("Plague Leech"),lib.GetSpellCD("Unholy Blight")) then
			return lib.SimpleCDCheck("it",lib.GetAura({"Frost Fever"}))
		end
		return lib.SimpleCDCheck("it",math.max(lib.GetAura({"Frost Fever"})-cfg.des_update,lib.GetAura({"Unholy Blight"})))
	end
	
	cfg.case["ps_bp"] = function()
		if lib.GetAura({"bp"})>=math.min(lib.GetSpellCD("Outbreak"),lib.GetSpellCD("Plague Leech"),lib.GetSpellCD("Unholy Blight")) then
			lib.SimpleCDCheck("ps",lib.GetAura({"bp"}))
		else
			return lib.SimpleCDCheck("ps",math.max(lib.GetAura({"bp"})-cfg.des_update,lib.GetAura({"Unholy Blight"})))
		end
	end
	
	cfg.case["ps_bp_unholy"] = function()
		if lib.GetAura({"Killing Machine"})>0 then return nil end
		if lib.GetAura({"bp"})>=math.min(lib.GetSpellCD("Outbreak"),lib.GetSpellCD("Plague Leech"),lib.GetSpellCD("Unholy Blight")) then
			lib.SimpleCDCheck("ps",math.max(lib.RuneTypeCD(2),lib.GetAura({"bp"})))
		end
		if lib.GetNumRune(2)>0 then
			return lib.SimpleCDCheck("ps",math.max(lib.RuneTypeCD(2),lib.GetAura({"bp"})-cfg.des_update,lib.GetAura({"Unholy Blight"})))
		end
		return nil
	end
	
	if cfg.hiderunes then lib.hideRuneFrame() end
	
	lib.DK_events()

	lib.CD = function()
		lib.CDadd("Kick")
		if cfg.talents["Icy Touch Glyph"] then
			lib.CDadd("Dispell",nil,nil,nil,function(state)
				if state then
					if state == "on" then
						cfg.dispell["target"].enabled=true
					else
						cfg.dispell["target"].enabled=false
					end
				else
					if cfg.dispell["target"].enabled then
						cfg.dispell["target"].enabled=false
					else
						cfg.dispell["target"].enabled=true
					end
				end
				--print(cfg.dispell["target"].enabled)
				cfg.Update=true
				return cfg.dispell["target"].enabled
			end)
			lib.CDaddLabel("Dispell","G")
		end
		lib.CDEnable(45477)
		lib.CDadd("Death Strike")
		lib.CDadd("Death Siphon")
		lib.CDadd("Pillar of Frost")
		lib.CDadd("Obliteration")
		lib.CDadd("Remorseless Winter")
		lib.CDadd("Summon Gargoyle")
		lib.CDaddTimers("Summon Gargoyle","Summon Gargoyle",function(self, event, unitID,spellname, rank, castid, spellID)
			if event=="UNIT_SPELLCAST_SUCCEEDED" and unitID=="player" and spellID==lib.GetSpellId("Summon Gargoyle") then
				CooldownFrame_SetTimer(self.cooldown,GetTime(),cfg.gargoyle,1)
			end
		end
		,{"UNIT_SPELLCAST_SUCCEEDED"})
		lib.CDadd("Dark Transformation")
		lib.CDadd("Soul Reaper")
		lib.CDaddTimers("Soul Reaper","Soul Reaper_player","aura",nil,true,{0, 0, 1})
		lib.CDadd("Death and Decay")
		lib.CDadd("Epidemic")
		lib.CDadd("drw")
		lib.CDadd("Blighted Rune Weapon")
		
		--lib.CDadd("Hungering Rune Weapon")
		lib.CDadd("Empower Rune Weapon")
		lib.CDadd("Sindragosa")
		lib.CDadd("Blood Tap",nil,true)
		
		lib.CDadd("Vampiric Blood")
		lib.CDadd("Icebound Fortitude")
		lib.CDadd("Rune Tap")
		lib.CDadd("Anti-Magic Shell",nil,nil,"turnoff")
		
	end
	cfg.onpower=true
end
end